<?php
/**
 * Created by PhpStorm.
 * User: Mead
 * Date: 2019/9/4
 * Time: 9:36 AM
 */

namespace App\Models;

use App\Servers\BikeControl;

trait BoxSettingTraitModel
{
    private static $time_find_order_tags = 'box_setting:';

    public function byNoGetSetting($box_no)
    {
        $setting = $this->redis->get(self::$time_find_order_tags . $box_no);

        if ($setting) {
            return unserialize($setting);
        }
        $setting = $this->db->select('pulse,freq,vibfilterremindt,maxecuspeed')->from('box_binding')->where('box_no = ' . $box_no . ' and is_binding = 1')->row();
        if (!$setting) return false;

        $new_setting = [
            'PULSE=' . $setting['pulse'],
            'FREQ=' . $setting['freq'],
            'MAXECUSPEED=' . $setting['maxecuspeed'],
            'VIBFILTERREMINDT=' . $setting['vibfilterremindt'],
            'MAXSPEEDPERCENT=' . BikeControl::maxecuspeedToMaxspeedpercent($setting['maxecuspeed']),
        ];

        $this->redis->setex(self::$time_find_order_tags . $box_no, 1 * 60 * 60, serialize($new_setting));

        return $setting;
    }
}