<?php
/**
 * Created by PhpStorm.
 * User: Mead
 * Date: 2019/9/3
 * Time: 8:05 PM
 */

namespace App\Servers\Weikemu\Transforms;

use App\Models\BoxSettingTraitModel;
use App\Models\WarningLogTraitModel;
use App\Servers\BaseServer;

/**
 * 心跳报文
 * Class LoginServer
 * @package App\Servers
 */
class HeartTransform extends BaseServer
{
    use BoxSettingTraitModel, WarningLogTraitModel;

    public function main($body)
    {
        $data = $this->decode($body);


        return $this->response();

    }

    /**
     * 解析装载的状态消息
     * @param $body
     * @return array
     * User: Mead
     */
    private function decode($body)
    {

        $i = 0;
        $box_time = self::stitching($body, $i, 4);
        $i += 4;
        $imei = substr(self::stitching($body, $i, 8), 0, -1); // i=4

        return [
            'box_time' => $this->decodeTime($box_time),
            'imei' => $imei
        ];
    }

    /**
     * 状态响应
     * @param $login_type
     * @return array
     * User: Mead
     */
    public function response($login_type = '00')
    {
        $body = [
            '5b',
            '0000'
        ];
        return $body;
    }

}
