<?php
/**
 * Created by PhpStorm.
 * User: Mead
 * Date: 2019/9/3
 * Time: 8:05 PM
 */

namespace App\Servers\Weikemu\Transforms;

use App\Maps\WarningLogMap;
use App\Models\BoxSettingTraitModel;
use App\Models\WarningLogTraitModel;
use App\Servers\BaseServer;

/**
 * 登录报文
 * Class LoginServer
 * @package App\Servers
 */
class LoginTransform extends BaseServer
{
    use BoxSettingTraitModel, WarningLogTraitModel;

    /**
     * 处理设备序列号
     * @param $no
     * @return bool|string
     * User: Mead
     */
    private
    static function box_no($no)
    {
        return substr($no, 0, 9);
    }

    public function main($body)
    {
        $data = $this->decode($body);
        // 判断有没有该车

        $bike_no = $_SESSION['bike_no'];

        if (!$bike_no) {
            return false;
        }

        $cols['is_link'] = \App\Maps\BikeMap::LINK_ONLINE;
//        $this->db->update('bikes')->where('box_no = ' . $data['box_no'])->cols($cols)->query();
        $box_no = $data['box_no'];
        $this->db->update('bikes')->where("box_no = '{$box_no}'")->cols($cols)->query();

        return $this->response();

    }

    /**
     * 解析装载的登录数据
     * @param $body
     * @return array
     * User: Mead
     */
    private function decode($body)
    {
        $top34Data = $this->decodeWeiKeMuTop34($body);
        $i = 34;
        $software_version = hexdec(self::stitching($body, $i, 4));
        $i += 4;
        $hardware_type = hexdec(self::stitching($body, $i, 2));

        return array_merge($top34Data, [
            'software_version' => $software_version,
            'hardware_type' => $hardware_type
        ]);
    }

    /**
     * 登录响应
     * @param $login_type
     * @return array
     * User: Mead
     */
    public function response($login_type = '00')
    {
        $body = [
            '5b',
            '0000'
        ];
        return $body;
    }
}
