<?php
/**
 * Created by PhpStorm.
 * User: Mead
 * Date: 2019/9/3
 * Time: 8:05 PM
 */

namespace App\Servers\Weikemu\Transforms;

use App\Maps\BikeMap;
use App\Models\BoxSettingTraitModel;
use App\Models\WarningLogTraitModel;
use App\Servers\BaseServer;

/**
 * 状态报文
 * Class LoginServer
 * @package App\Servers
 */
class StatusTransform extends BaseServer
{
    use BoxSettingTraitModel, WarningLogTraitModel;

    /**
     * 处理设备序列号
     * @param $no
     * @return bool|string
     * User: Mead
     */
    private
    static function box_no($no)
    {
        return substr($no, 0, 9);
    }

    public function main($body)
    {
        $data = $this->decode($body);

        $battery_power = $data['battery_voltage'];
        if ($battery_power > 10) {
            $cols['battery_power'] = $battery_power;
            $cols['is_low_battery_power'] = BikeMap::BATTERY_POWER_OK;
            if ($cols['battery_power'] <= self::$max_ride_v) {
                $cols['is_low_battery_power'] = BikeMap::BATTERY_POWER_LOW;
            }
//            $this->db->update('bikes')->where('box_no = ' . $data['box_no'])->cols($cols)->query();
            $box_no = $data['box_no'];
            $this->db->update('bikes')->where("box_no = '{$box_no}'")->cols($cols)->query();
        }

        return $this->response();

    }

    /**
     * 解析装载的状态消息
     * @param $body
     * @return array
     * User: Mead
     */
    private function decode($body)
    {
        $top34Data = $this->decodeWeiKeMuTop34($body);
//        $i = 34;

        return $top34Data;
    }

    /**
     * 状态响应
     * @param $login_type
     * @return array
     * User: Mead
     */
    public function response($login_type = '00')
    {
        $body = [
            '5b',
            '0000'
        ];
        return $body;
    }


}
