<?php
/**
 * Created by PhpStorm.
 * User: Mead
 * Date: 2019/9/3
 * Time: 8:05 PM
 */

namespace App\Servers\Weikemu\Transforms;

use App\Models\BoxSettingTraitModel;
use App\Models\WarningLogTraitModel;
use App\Servers\BaseServer;
use App\Servers\Weikemu\Models\CacheLogTraitModel;

/**
 * 语音大小配置响应报文
 * Class LoginServer
 * @package App\Servers
 */
class VoiceLargeTransform extends BaseServer
{
    use CacheLogTraitModel;

    public function main($body)
    {
        $data = $this->decode($body);
        $this->cacheLog($data['box_no'], $this->msg_id, [
            'SERVER' => $data['server_ip'] . ':' . $data['server_port']
        ]);
        return false;

    }

    /**
     * 解析装载的状态消息
     * @param $body
     * @return array
     * User: Mead
     */
    private function decode($body)
    {

        $i = 0;
        $mid = self::stitching($body, $i, 2);
        $i += 2;

        return [
            'mid' => $mid,
            'box_no' => ''
        ];
    }

    /**
     * 状态响应
     * @param $login_type
     * @return array
     * User: Mead
     */
    public function response($login_type = '00')
    {
        $body = [
            '5b',
            '0000'
        ];
        return $body;
    }

}
